;===============================================
; Smw Castle Intro "Disassembly"
; coded by MetalJo
;
; Note:
; This is for everyone who wanted to change the 
; castle intro in SMW
;
: Note:
; This doesn't works with Yoshi ;w;
;
; Note:
; Give credit if used :3
;
;===============================================

!Spd = $14 
!Dir = $01 
!Pos = $F0 

;===============================================
; Init and Main
;===============================================

	print "INIT ",pc
	RTL
	
	print "MAIN ",pc
	PHB
	PHK
	PLB
	JSR MainCode
	PLB
	RTL
	
;===============================================
; Main Code
;===============================================

MainCode:
	LDA #$01					; Mario direction
	STA $76						; direction adress
	LDA $C2,x					; If State is
	CMP #$01					; 01
	BEQ NoWalk					; don't walk
	CMP #$02					; 02
	BEQ NoWalk					; don't walk
NoWalk:		
	JSR GFXCode					; jump to gfx code
	JSR Pointers					; jump to states
	LDA $14C8,x					; if sprite
	CMP #$08					; is dead
	BNE Return					; return
	LDA $9D						; if sprite is locked
	BNE Return					; return
	LDA $15
	AND #$FF
	BEQ Return
	STZ $1DFC
	STZ $1DF9
	STZ $1DFA
	LDA #$04
	STA $C2,x
Return:
	RTS							; return
Contact:
	JSL $03B664					; check for contact
   	JSR GetSpriteClipping		; jump to clipping routine
   	JSL $03B72B					; clipping subroutine
    	BCS OpenDoor
	RTS							; return
OpenDoor:
	LDA #$01					; load 01
	STA $C2,x					; in state adress
	RTS							; return
Pointers:
	LDA $C2,x					; state adress
	JSL $0086DF					; state subroutine
	dw Walk						; 00 - return
	dw GoUp						; 01 - go upwards
	dw MarioWalk					; 02 - Mario walks again
	dw GoDown					; 03 - go downwards
	dw TeleportMario				; 04 - teleport Mario
	RTS						; return
Walk:
	JSR Contact					; jump to contact code
	LDA #!Spd					; x-speed value
	STA $7B						; x-speed adress
	STZ $7D
	RTS
GoUp:
	STZ $7B
	STZ $7D						; set Mario's y-speed to 0
	LDA #$03					; mario looks up
	STA $13E0					; mario pose
	LDA #$0F					; door open sfx
	STA $1DFC					; sfx bank
	LDA #$F8					; y-speed
	STA $AA,x					; y-speed adress
	JSL $01802A					; set updated position
	LDA $D8,x
	CMP #$00
	BEQ NextA
	CMP #$01
	BEQ NextA
	CMP #$02
	BEQ NextA
	RTS
NextA:
	STZ $AA,x					; set y-speed to 0
	INC $C2,x					; increase the state
	RTS							; return
MarioWalk:
	STZ $7D
	LDA #!Spd					; load 0F
	STA $7B						; into x-speed adress
	LDA $94
	CMP #!Pos
	BEQ NextM
	CMP #$EF
	BEQ NextM
	CMP #$EE
	BEQ NextM
	CMP #$EC
	BEQ NextM
	RTS			
NextM:
	INC $C2,x
	RTS				; return
GoDown:
	STZ $7D
	STZ $7B
	LDA #$0D					; load 03
	STA $AA,x					; into sprite's y-speed
	JSL $01802A					; set updated position
	LDA $163E,x					; if timer isn't 0
	BNE DTimer					; go to next code
	LDA #$41						; load FF
	STA $163E,x					; into timer
	RTS							; return
DTimer:
	LDA $163E,x					; If timer is
	CMP #$01					; 01
	BEQ DSet1					; go to next code
	RTS							; return
DSet1:
	LDA $163E,x					; if timer isn't 0
	BNE DTimer1					; go to next code
	LDA #$FF					; load FF
	STA $163E,x					; into timer
	RTS							; return
DTimer1:
	LDA $163E,x					; If timer is
	CMP #$01					; 01
	BEQ NextB					; go to next code
	RTS							; return
NextB:
	INC $C2,x					; increase state
	LDA #$09					; bullet bill shot sfx
	STA $1DFC					; sfx bank
	RTS							; return
TeleportMario:
	STZ $7D
	STZ $7B
	LDA #$06 					; vertical pipe
	STA $71						; animation trigger
	STZ $88						; set go into pipe time to 0
	STZ $89						; 'Enter a right-facing horizontal pipe' code
	RTS							; return						; Return
X_OFFSET: 
					db $18,$18,$08,$08,$18,$18,$08,$08,$28,$28,$28,$28,$38,$38,$38,$38
                    
Y_OFFSET:           
					db $10,$00,$10,$00,$30,$20,$20,$30,$00,$10,$20,$30,$00,$10,$20,$30
					
GFXCode:
   	JSR GET_DRAW_INFO
        LDA $13
        LSR                      ;\  A
        AND #$04                 ; | N
        ASL                      ; | I
        ASL                      ; | MATION
        STA $03                  ;/


	LDX #$00	;Reset OAM

OAM_Loop:

	LDA $00
	CLC
	ADC X_OFFSET,x
	STA $0300,y	;Xpos

	LDA $01
	CLC
	ADC Y_OFFSET,x
	STA $0301,y	;Ypos


        PHX
        TXA
        CLC
        ADC $03
        TAX
        LDA #$00
        STA $0302,y
        PLX


 PHX
 LDX $15E9
 LDA $15F6,x                    
 PLX
 ORA $64
 STA $0303,y

	INY
	INY
	INY
	INY
             
	INX
	CPX #$0C
	BNE OAM_Loop

	LDX $15E9	;Restore sprite index
	LDY #$02        ;16x16
        LDA #$0B        ;Number of tiles to draw - 1 (0B)
        JSL $01B7B3	;Finish OAM Write

	RTS
	
SPR_T1:              
db $0C,$1C
SPR_T2:             
db $01,$02

GET_DRAW_INFO:       
	STZ $186C,x           
	STZ $15A0,x             
	LDA $E4,x               
	CMP $1A                 
	LDA $14E0,x             
	SBC $1B                 
	BEQ ON_SCREEN_X         
	INC $15A0,x             

ON_SCREEN_X:         
	LDA $14E0,x             
	XBA	 
	LDA $E4,x               
	REP #$20                
	SEC	
	SBC $1A                 
	CLC	
	ADC #$0040            
	CMP #$0180            ;  | IF YOU READ THIS, YOU WIN A COOKIE! PM ME AND I'LL GIVE YOU A FREE ASM HACK WOOHOO!
	SEP #$20                ;  |
	ROL A                   ;  |
	AND #$01                ;  |
	STA $15C4,x             ; / 
	BNE INVALID             ; 
	
	LDY #$00                ; \ set up loop:
	LDA $1662,x             ;  | 
	AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
	BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
	INY	 ; / 
ON_SCREEN_LOOP:      LDA $D8,x               ; \ 
	CLC	 ;  | set vertical offscreen if necessary
	ADC SPR_T1,y            ;  |
	PHP	 ;  |
	CMP $1C                 ;  | (vert screen boundry)
	ROL $00                 ;  |
	PLP	 ;  |
	LDA $14D4,x             ;  | 
	ADC #$00                ;  |
	LSR $00                 ;  |
	SBC $1D                 ;  |
	BEQ ON_SCREEN_Y         ;  |
	LDA $186C,x             ;  | (vert offscreen)
	ORA SPR_T2,y            ;  |
	STA $186C,x             ;  |
ON_SCREEN_Y:         DEY	 ;  |
	BPL ON_SCREEN_LOOP      ; /

	LDY $15EA,x             ; get offset to sprite OAM
	LDA $E4,x               ; \ 
	SEC	 ;  | 
	SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
	STA $00                 ; / 
	LDA $D8,x               ; \ 
	SEC	 ;  | 
	SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
	STA $01                 ; / 
	RTS	 ; return

INVALID:             PLA	 ; \ return from *main gfx routine* subroutine...
	PLA	 ;  |    ...(not just this subroutine)
	RTS	 ; /
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite clipping routine
; ripped and modified by Roy, then modified more by Sonikku
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
GetSpriteClipping:
PHY
PHX
TXY
LDA $00E4,y
CLC
ADC #$08  ; Starting X pos of sprite clipping = sprite center position - $0C ($0C pixels to the left)
STA $04
LDA $14E0,y
ADC #$00
STA $0A
LDA #$30                ; Width of sprite clipping
STA $06
LDA $00D8,y
SEC
SBC #$10                ; Starting Y pos of sprite clipping = sprite center position - $2C ($2C pixels above)
STA $05
LDA $14D4,y
SBC #$00
STA $0B
LDA #$50                ; Height of sprite clipping
STA $07
PLX
PLY
RTS